VERSION 5.00
Begin VB.UserControl Resizer 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Image Image1 
      Height          =   855
      Left            =   1800
      Top             =   1560
      Width           =   1215
   End
End
Attribute VB_Name = "Resizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private difL() As Long
Private difR() As Long
Private difT() As Long
Private difB() As Long
Private CW() As Long
Private CH() As Long
Private Cor As Collection

Private WithEvents m_frm As Form
Attribute m_frm.VB_VarHelpID = -1

Public Property Set intfrm(obj As Object)
    Dim ctr As Control
    Dim i As Integer
    If obj Is Nothing Then
        Set m_frm = Nothing
        Exit Property
    End If
    If TypeOf obj Is Form = False Then
        MsgBox "Set the Resizer control to the current form or to Nothing", vbCritical
    Else
        Set m_frm = obj
        
        ReDim difL(m_frm.Controls.Count - 1)
        ReDim difR(m_frm.Controls.Count - 1)
        ReDim difT(m_frm.Controls.Count - 1)
        ReDim difB(m_frm.Controls.Count - 1)
        ReDim CH(m_frm.Controls.Count - 1)
        ReDim CW(m_frm.Controls.Count - 1)
        
        Set Cor = New Collection
        For i = 0 To m_frm.Controls.Count - 1
            Set ctr = m_frm.Controls(i)
            If TypeOf ctr Is Resizer = False Then
                CH(i) = ctr.Height
                CW(i) = ctr.Width
                difR(i) = m_frm.Width - (ctr.Width + ctr.Left)
                Cor.Add difR(i)
                difL(i) = ctr.Left
                Cor.Add difL(i)
                difT(i) = ctr.Top
                Cor.Add difT(i)
                difB(i) = m_frm.Height - (ctr.Top + ctr.Height)
                Cor.Add difB(i)
            End If
        Next
    End If
End Property

Private Sub Action()
    Dim ctr As Control
    Dim i As Integer
    Dim FRM As Form
    Set FRM = m_frm
    For i = 0 To FRM.Controls.Count - 1
        Set ctr = FRM.Controls(i)
        If TypeOf ctr Is Resizer = False Then
            ctr.Top = difT(i)
            ctr.Left = FRM.Width * difL(i) / (difL(i) + CW(i) + difR(i))
            ctr.Top = FRM.Height * difT(i) / (difT(i) + CH(i) + difB(i))
            ctr.Width = FRM.Width * CW(i) / (difL(i) + CW(i) + difR(i))
            ctr.Height = FRM.Height * CH(i) / (difT(i) + CH(i) + difB(i))
        End If
    Next

End Sub

Private Sub m_frm_Resize()
    Action
End Sub

Private Sub UserControl_Paint()
    Image1.Move 0, 0
    UserControl.Height = Image1.Height
    UserControl.Width = Image1.Width
End Sub

Private Sub UserControl_Resize()
    UserControl.Refresh
    Image1.Move 0, 0
    UserControl.Height = Image1.Height
    UserControl.Width = Image1.Width
End Sub

Private Sub UserControl_Initialize()
    Image1.Picture = LoadPicture(App.Path & "\Rulers.ico")
End Sub
